$(document).ready(function() {
    var map;
    var FREQ = 10000;
    var repeat = true;
    var lat_1 = "0.0"; var lng_1 = "0.0"; // Last position
    var markers = [];
    
    function showFrequency(){
		$("#freq").html("Page mise à jour toutes les " + FREQ/1000 + " second(s).");
	}

    $("#btnStart").click(function() {
        repeat = true;
        startAJAXCalls();
        showFrequency();       
    });

    $("#btnStop").click(function() {
        repeat = false;
        $("#freq").html("En pause.");
    });

    $('#ClearMarkers').click(function() {
        deleteMarkers();
    });

    $('#DisplayJourney').click(function() {
        var fileWay = "data/gpsall.xml";
        viewAllCoordinates(fileWay);
    });

    $('#Simulation').click(function() {
        var fileWay = "data/gpsSimul.xml";
        viewAllCoordinates(fileWay);
    });

// Functions --------------------------------------------------------------------
    
    // Display marker on map every FREQ ms
    function startAJAXCalls() {
        if (repeat) {
            setTimeout(function() {
                viewOneCoordinate();
                startAJAXCalls();
            },
                FREQ
            );
        }
    }

    function initialize() {
        var latlng = new google.maps.LatLng(47.074046, 2.405759);
        var mapOpts = {
            zoom: 18,
            center: latlng,
            mapTypeId: google.maps.MapTypeId.HYBRID
        };
        map = new google.maps.Map(document.getElementById("map_canvas"), mapOpts);
    }
    
    // Display last journey
    function viewAllCoordinates(fileWay) {
        $.ajax({
            url: fileWay,
            cache: false,
            dataType: "xml",
            success: function(xml) {
                $(xml).find("coordonnees").each(function() {
                    var lat = $(this).find("latitude").text();
                    var lng = $(this).find("longitude").text();
                    var pos = $(this).find("position").text();
                    var latlng = new google.maps.LatLng(lat, lng);
                    var marker = new google.maps.Marker({
                        position: latlng,
                        map: map,
                        label: pos
                    });
                    markers.push(marker);
                });
            }
        });
    }
    // Display a position
    function viewOneCoordinate() {
        $.ajax({
            url: "data/gps.xml",
            cache: false,
            dataType: "xml",
            success: function(xml) {
                $(xml).find("coordonnees").each(function() {
                    var lat = $(this).find("latitude").text();
                    var lng = $(this).find("longitude").text();
                    if ((lat != lat_1) || (lng != lng_1)) {
                        var pos = $(this).find("position").text();
                        var latlng = new google.maps.LatLng(lat, lng);
                        var marker = new google.maps.Marker({
                            position: latlng,
                            map: map,
                            label: pos
                        });
                        markers.push(marker);
                        lat_1 = lat; lng_1 = lng;
                    }
                });
            }
        });
    }

    // Sets the map on all markers in the array.
    function setMapOnAll(map) {
        for (var i = 0; i < markers.length; i++) {
            markers[i].setMap(map);
        }
    }

    // Removes the markers from the map, but keeps them in the array.
    function clearMarkers() {
        setMapOnAll(null);
    }

    // Deletes all markers in the array by removing references to them.
    function deleteMarkers() {
        clearMarkers();
        markers = [];
        lat_1 = "0.0"; lng_1 = "0.0";
    }

    // -----------------------------------------------
    initialize(); // Map on PEM
    showFrequency();
    startAJAXCalls();

});